%Problem 4.1

clear all
close all
clc

%Fixed points - from analytic calculation
fp1 = [1/2 1/4]
fp2 = [0 0]

%Jacobian matrix at the fixed points
J_fp1 = [-1 1; 2 -1]
J_fp2 = [-1 0; 2 -1]

[v1,d1] = eig(J_fp1);
[v2,d2] = eig(J_fp2);

%Eigenvalues
d1 = diag(d1)   %Saddle point
d2 = diag(d2)   %Attractor

% vector field plot
Nv = 50; % Nv * Nv arrows
%     define X and Y grid
[X, Y] = meshgrid(linspace(-3,3,Nv), linspace(-3,3,Nv));
%     plug into the differential equations: dx = y^2 - x, dy = 2x - y
dX = Y.^2 - X;
dY = 2*X - Y;

% example trajectories starting from [x,y] for t=0...30s
[t0,z0] = nde2d(linspace(0,30,1000), [-.01,-.01]);
[t1,z1] = nde2d(linspace(0,30,1000), [-1, 1.5]);

[t2,z2] = nde2d(linspace(0,30,1000), [0.5, -1]); %Still drawn by attractor
[t3,z3] = nde2d(linspace(0,30,1000), [0.8, -1]); %Unstable saddle point

% plot the flow (vector field)
figure; hold on; grid on;
quiver(X, Y, dX, dY, 'k');
 xlim([min(min(X)), max(max(X))]); ylim([min(min(Y)), max(max(Y))]);
xlabel('x'); ylabel('y'); title('PHASE SPACE');

plot([0, 1/4], [0, 1/2], 'ro', 'MarkerSize', 10); % fixed points

plot(z0(:,1), z0(:,2), 'g-'); % example trajectories
plot(z1(:,1), z1(:,2), 'b-'); % example trajectories
plot(z2(:,1), z2(:,2), 'm-'); % example trajectories
plot(z3(:,1), z3(:,2), 'r-'); % example trajectories

legend('flow', 'fixed pts', 'example traj.',...
   'Location','SouthWest');

 %% plot the trajecories over time
 figure; hold on; grid on;
 plot(t0, z0(:,1), 'b')
 plot(t0, z0(:,2), 'r')
 legend('x(t)', 'y(t)')
 xlabel('t')
 ylabel('x(t),y(t)')
 
 figure; hold on; grid on;
 plot(t1, z1(:,1), 'b')
 plot(t1, z1(:,2), 'r')
 legend('x(t)', 'y(t)')
 xlabel('t')
 ylabel('x(t),y(t)')

 figure; hold on; grid on;
 plot(t2, z2(:,1), 'b')
 plot(t2, z2(:,2), 'r')
 legend('x(t)', 'y(t)')
 xlabel('t')
 ylabel('x(t),y(t)')

  %The diverging one
 figure; hold on; grid on;
 plot(t3, z3(:,1), 'b')
 plot(t3, z3(:,2), 'r')
 legend('x(t)', 'y(t)')
 xlabel('t')
 ylabel('x(t),y(t)')
 xlim([0 12])
 
 
 
 