%Simulate Lorenz equations

clear all
close all
clc

%Parameters
global sigma r b;

sigma = 10;
b = 8/3;

r = 8;        %stable fixed point
%r = 28;        %strange attractor 
%r = 166;      %periodic
%r = 166.7;    %intermittent chaos

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% iterate a trajectory
N = 10000;      %Trajectory points %20000 for full one
t_end = 100;    %simulation end time
%N = 2000;     %for 2 initial conditions
%t_end = 30;

x_0 = [.1 .1 .1];   %initial condition
t_vec = linspace(0,t_end,N);
[t_t1, z_t1] = nde3d_lorenz(t_vec, x_0);

x = z_t1(:,1);
y = z_t1(:,2);
z = z_t1(:,3);

if(0)
  %another, slightly different initial condition
  x_0_a = x_0 + 1e-5;
  [t_t1, z_t1] = nde3d_lorenz(t_vec, x_0_a);
  
  x_a = z_t1(:,1);
  y_a = z_t1(:,2);
  z_a = z_t1(:,3);
end


figure, hold on
%plot3(x, y, z, 'b-')
start_index = 1; lw = 1;
plot3(x(start_index:end), y(start_index:end), z(start_index:end), 'b-', 'linewidth', lw)
plot3(x(1), y(1), z(1), 'b*')
text(x(1), y(1), z(1), 'Start')
hold on, grid on
%plot3(x_a(start_index:end), y_a(start_index:end), z_a(start_index:end), 'r--', 'linewidth', lw)
xlabel('x')
ylabel('y')
zlabel('z')
title('Phase Space for Lorenz Equations')

return

figure
subplot(311), hold on; grid on;
plot(t_t1, x, 'b-')
ylabel('x(t)')

subplot(312), hold on; grid on;
plot(t_t1, y, 'r-')
ylabel('y(t)')

subplot(313), hold on; grid on;
plot(t_t1, z, 'k-')
xlabel('t [s]')
ylabel('z(t)')

return

%Frequency domain - compare intermittency with periodic solution
figure
plot(abs(fft(y(1000:end))))
hold on; grid on 

return
figure
diff_y = y - y_a;
plot(t_t1, diff_y)
hold on; grid on




